

#include <string.h>

#include "pac7311-grab-jpeg.h"
#include "pac7311-grab.h"
#include "pac7311-grab-jpeg-tinyjpeg.h"

#include "pac7311-grab-jpeg-header.c"




unsigned char *pac7311_jpeg_get_header(int image_width, int image_height, int *size)
{
	pac7311_jpeg_header[PAC7311_JPEG_HEADER_SIZE_POS + 0] = (unsigned char) (image_height >> 8);
	pac7311_jpeg_header[PAC7311_JPEG_HEADER_SIZE_POS + 1] = (unsigned char) (image_height & 0xff);
	pac7311_jpeg_header[PAC7311_JPEG_HEADER_SIZE_POS + 2] = (unsigned char) (image_width >> 8);
	pac7311_jpeg_header[PAC7311_JPEG_HEADER_SIZE_POS + 3] = (unsigned char) (image_width & 0xff);

	*size = PAC7311_JPEG_HEADER_SIZE;

	return pac7311_jpeg_header;
}


int pac7311_jpeg_write_jpeg(unsigned char *stream, int stream_size,
                            unsigned int image_width, unsigned int image_height,
                            unsigned char jpeg_mcu_marker, FILE *file)
{
	int retval = 0;
	struct jdec_private *jdec;
	unsigned long jpeg_size;
	unsigned char *jpeg;

	jdec = tinyjpeg_init();

	if (jdec == NULL)
	{
		retval = 1;
		goto exit0;
	}

	if (!init_tinyjpeg_pac7311(jdec, image_width, image_height,
                                   stream, stream_size))
        {
        	retval = 2;
        	goto exit1;
        }

	if (tinyjpeg_pac7311_parse_copy(jdec, jpeg_mcu_marker))
	{
		retval = 3;
		goto exit1;
	}
	
	jpeg = tinyjpeg_pac7311_get_outbuf(jdec, &jpeg_size);

	if (!jpeg)
	{
		retval = 4;
		goto exit1;
	}
	
	if (fwrite(jpeg, jpeg_size, 1, file) != 1)
	{
		retval = 5;
		goto exit1;
	}

exit1:
	tinyjpeg_free(jdec);

exit0:
	return retval;
}

