
#ifndef _PAC7311_GRAB_H_
#define _PAC7311_GRAB_H_


#define MAX_CMD_LINE_SIZE 1024

#define CMD_MAX_ARGS 5
#define CMD_END NULL


#define DEBUG 0

#if (DEBUG == 1)
#define PDEBUG(MSG, ARGS...) fprintf(stderr, MSG, ##ARGS);
#else
#define PDEBUG(MSG, ARGS...) ;
#endif


#define PFUNC_CALLED PDEBUG("%s called\n", __FUNCTION__);



typedef enum {

	CMD_ARG_UCHAR,
	CMD_ARG_ULONG,
	CMD_ARG_STR,
	CMD_ARG_HEX_STR,
	
	CMD_ARG_END
	
} arg_type_type;


typedef union {

	unsigned char uchar;
	unsigned long ulong;
	char str[MAX_CMD_LINE_SIZE];
	unsigned char hex_str[MAX_CMD_LINE_SIZE];
	
} arg_value_type;


typedef int (*cmd_handler_type)(int pac7311_fd, arg_value_type arg_values[]);


typedef struct cmd_exec_struct {

	cmd_handler_type handler;
	arg_value_type arg_values[CMD_MAX_ARGS];

	int line;

	struct cmd_exec_struct *next;
		
} cmd_exec_type;


typedef struct {

	char *name;
	arg_type_type arg_types[CMD_MAX_ARGS + 1];
	
	cmd_handler_type handler;

} cmd_list_type[];


#endif
