
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>

#include "pac7311-stream.h"


int pac7311_stream_open(char *filename)
{
	return open(filename, O_RDONLY, 0);
}

int pac7311_stream_close(int fd)
{
	return close(fd);
}

int pac7311_stream_stream_start(int fd)
{
	return ioctl(fd, PAC7311_STREAM_IOCTL_STREAM_START);
}

int pac7311_stream_stream_stop(int fd)
{
	return ioctl(fd, PAC7311_STREAM_IOCTL_STREAM_STOP);
}

int pac7311_stream_reg_get(int fd, pac7311_stream_reg_t reg, pac7311_stream_regval_t *val)
{
	int retval;
	struct pac7311_stream_reg st_reg;
	
	st_reg.reg = reg;
	retval = ioctl(fd, PAC7311_STREAM_IOCTL_REG_GET, &st_reg);
	*val = st_reg.val;
	
	return retval;
}

int pac7311_stream_reg_set(int fd, pac7311_stream_reg_t reg, pac7311_stream_regval_t val)
{
	struct pac7311_stream_reg st_reg;
	
	st_reg.reg = reg;
	st_reg.val = val;
	
	return ioctl(fd, PAC7311_STREAM_IOCTL_REG_SET, &st_reg);
}


int pac7311_stream_control_msg_send(int fd, int index, unsigned char *data, unsigned int len)
{
	struct pac7311_stream_control_msg st_msg;
	int retval = 0;

	if (!(st_msg.data = (char *) malloc(len * sizeof(char))))
	{
		return 1;
	}
	
	memcpy(st_msg.data, data, len);

	st_msg.index = index;
	st_msg.len = len;
	
	retval = ioctl(fd, PAC7311_STREAM_IOCTL_CONTROL_MSG_SEND, &st_msg);
	
	free(st_msg.data);
	
	return retval;
}
