
#ifndef _USB_PAC7311_RINGBUF_H_
#define _USB_PAC7311_RINGBUF_H_

#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/kref.h>
#include <asm/uaccess.h>
#include <asm/spinlock.h>

/* the ringbuffer declaration */
struct usb_pac7311_ringbuf {
	rwlock_t	lock;

	unsigned char *	buffer;
	
	size_t		size;       /* size of the total data the ringbuffer can hold */
	size_t		start, end; /* start and end of the _data_ in the ringbuffer */
};



static size_t ringbuf_init(struct usb_pac7311_ringbuf **ringbuf_p, size_t size);
static void ringbuf_destroy(struct usb_pac7311_ringbuf *ringbuf);
static void ringbuf_reset(struct usb_pac7311_ringbuf *ringbuf);
static size_t ringbuf_data_size(struct usb_pac7311_ringbuf *ringbuf);
static size_t ringbuf_data_write(struct usb_pac7311_ringbuf *ringbuf, unsigned char *data, size_t count);
static size_t ringbuf_data_read(struct usb_pac7311_ringbuf *ringbuf, unsigned char *data, size_t count);
static int ringbuf_data_search(struct usb_pac7311_ringbuf *ringbuf, unsigned char *data, size_t count, size_t offset);
static int ringbuf_data_frame_read(struct usb_pac7311_ringbuf *ringbuf, unsigned char *data, size_t count);

#endif
