
#ifndef _USB_PAC7311_STREAM_H_
#define _USB_PAC7311_STREAM_H_


#include <asm/ioctl.h>


typedef unsigned char pac7311_stream_reg_t;
typedef unsigned char pac7311_stream_regval_t;


struct pac7311_stream_reg
{
	pac7311_stream_reg_t		reg;
	pac7311_stream_regval_t	val;
};


struct pac7311_stream_control_msg
{
	int	index;
	char	*data;
	int	len;
};


#define PAC7311_STREAM_IOCTL_MAGIC		'P'

#define PAC7311_STREAM_IOCTL_STREAM_START	\
		_IO(PAC7311_STREAM_IOCTL_MAGIC, 0)
#define PAC7311_STREAM_IOCTL_STREAM_STOP	\
		_IO(PAC7311_STREAM_IOCTL_MAGIC, 1)
#define PAC7311_STREAM_IOCTL_REG_SET		\
		_IOW(PAC7311_STREAM_IOCTL_MAGIC, 2, struct pac7311_stream_reg)
#define PAC7311_STREAM_IOCTL_REG_GET		\
		_IOR(PAC7311_STREAM_IOCTL_MAGIC, 3, struct pac7311_stream_reg)
#define PAC7311_STREAM_IOCTL_CONTROL_MSG_SEND	\
		_IOW(PAC7311_STREAM_IOCTL_MAGIC, 4, struct pac7311_stream_control_msg)
		
#define PAC7311_STREAM_IOCTL_MAX_NR		4


#endif
